import numpy as np
import matplotlib.pyplot as plt
from scipy.optimize import fsolve

#==============================================================================
# Explicit Euler
#==============================================================================
def stepExplicitEuler(syst_k, ht):
    
    return 
    

#==============================================================================
# Implicit Euler
#==============================================================================
def stepImplicitEuler(syst_k, ht):
    
    return 


#==============================================================================
# Simulation
#==============================================================================

def simulate(syst_k, t_interval = [0,1], h=0.01):
    
    sol_t = [syst_k[0]] 
    sol_v = [syst_k[1]] 
    
    ts = np.arange(t_interval[0]+h, t_interval[1], h)
    
    for t in enumerate(ts):  
        #syst_k = stepExplicitEuler(syst_k, h)
        #syst_k = stepImplicitEuler(syst_k, h)
        sol_t.append( syst_k[0])
        sol_v.append( syst_k[1])
    return sol_t, sol_v
#==============================================================================
# main
#==============================================================================

#setup
t_interval = [0,50]
t0 = t_interval[0]
te = t_interval[1]
h = 0.001
 
ini_cond = [np.deg2rad(30.), 0.]    
syst_k = np.array([ini_cond[0], ini_cond[1]])
sol_t, sol_v = simulate(syst_k, t_interval, h)
tt = np.arange( t0, te, h)
plt.plot(tt, sol_t)               